{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program treeview_extra;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2pixbuf;

const
  AZO_OSZLOP = 0;
  KEP_OSZLOP = 1;
  NEV_OSZLOP = 2;
  NOE_OSZLOP = 3;
  TAP_OSZLOP = 4;

type
  TAdat = record
    azo : integer;
    kep : PGdkPixbuf;
    nev : PGChar;
    noe : boolean;
    tap : integer;
  end;

var
  adat : array[0..31] of TAdat;
  i    : byte;

  foablak,
  vdoboz, hdoboz,
  be1, be2,
  gomb,
  gordito,
  treeview   : PGtkWidget;

  oszlop     : PGtkTreeViewColumn;
  ren1, ren2,
  ren3       : PGtkCellRenderer;
  ren4       : PGtkCellRendererProgress;
  alak       : PGtkListStore;
  ismetlo    : TGtkTreeIter;
  kijeloles  : PGtkTreeSelection;

procedure kijeloles_kiir;
var
  neve : PGChar;
begin
  if (gtk_tree_selection_get_selected
          (kijeloles, @alak, @ismetlo)) then
  begin
    gtk_tree_model_get (alak, @ismetlo, NEV_OSZLOP, @neve, -1);
    writeln (neve);
  end;
end;

procedure rendez;
begin
  gtk_tree_sortable_set_sort_column_id
      (alak, NEV_OSZLOP, GTK_SORT_ASCENDING);
end;

procedure sortorles;
begin
  if (gtk_tree_selection_get_selected
          (kijeloles, @alak, @ismetlo)) then
  begin
    gtk_list_store_remove (GTK_LIST_STORE (alak), @ismetlo);
  end;
end;

procedure sorbeszuras;
begin
  if i = 31 then
  begin
    writeln ('Elerted a max. 32. indexet!');
    exit;
  end;
  if gtk_entry_get_text (GTK_ENTRY (be1)) <> '' then
  begin
    i := i+1;
    adat[i].azo := i;
    adat[i].noe := gtk_toggle_button_get_active
                       (GTK_TOGGLE_BUTTON (be2));
    if adat[i].noe = true then
      adat[i].kep := gdk_pixbuf_new_from_file
                         ('no.png', NULL) else
      adat[i].kep := gdk_pixbuf_new_from_file
                         ('ffi.png', NULL);
    adat[i].nev := gtk_entry_get_text (GTK_ENTRY (be1));
    adat[i].tap := 0;
    gtk_list_store_append (alak, @ismetlo);
    gtk_list_store_set (alak, @ismetlo,
                          AZO_OSZLOP, adat[i].azo,
                          KEP_OSZLOP, adat[i].kep,
                          NEV_OSZLOP, adat[i].nev,
                          NOE_OSZLOP, adat[i].noe,
                          TAP_OSZLOP, adat[i].tap,
                          -1);
  end else
    writeln ('Ures a NEV mezo!');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  hdoboz := gtk_hbox_new (false, 0);
  gordito := gtk_scrolled_window_new (NULL, NULL);

  alak := gtk_list_store_new (5, G_TYPE_INT,
                                 GDK_TYPE_PIXBUF,
                                 G_TYPE_STRING,
                                 G_TYPE_BOOLEAN,
                                 G_TYPE_INT);
  treeview := gtk_tree_view_new_with_model (alak);
  ren1 := gtk_cell_renderer_pixbuf_new;
  ren2 := gtk_cell_renderer_text_new;
  ren3 := gtk_cell_renderer_toggle_new;
  ren4 := gtk_cell_renderer_progress_new;

  oszlop := gtk_tree_view_column_new_with_attributes
                (' # ', ren2, 'text',
                  AZO_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  oszlop := gtk_tree_view_column_new_with_attributes
                ('Kep:', ren1, 'pixbuf',
                  KEP_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  oszlop := gtk_tree_view_column_new_with_attributes
                ('Nev:', ren2, 'text',
                  NEV_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  oszlop := gtk_tree_view_column_new_with_attributes
                ('No-e?:', ren3, 'active',
                  NOE_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  oszlop := gtk_tree_view_column_new_with_attributes
                ('Tapasztalat:', GTK_CELL_RENDERER (ren4), 'value',
                  TAP_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  adat[0].nev := 'Szalmon Ella';
  adat[0].noe := true;
  adat[0].tap := 75;
  adat[1].nev := 'Kaja Egyed';
  adat[1].noe := false;
  adat[1].tap := 40;
  adat[2].nev := 'Kolle Gina';
  adat[2].noe := true;
  adat[2].tap := 15;

  for i := 0 to 2 do
  begin
    adat[i].azo := i;
    if adat[i].noe = true then
      adat[i].kep := gdk_pixbuf_new_from_file
                         ('no.png', NULL) else
      adat[i].kep := gdk_pixbuf_new_from_file
                         ('ffi.png', NULL);
    gtk_list_store_append (alak, @ismetlo);
    gtk_list_store_set (alak, @ismetlo,
                          AZO_OSZLOP, adat[i].azo,
                          KEP_OSZLOP, adat[i].kep,
                          NEV_OSZLOP, adat[i].nev,
                          NOE_OSZLOP, adat[i].noe,
                          TAP_OSZLOP, adat[i].tap,
                          -1);
  end;

  kijeloles := gtk_tree_view_get_selection
                (GTK_TREE_VIEW (treeview));
  gtk_tree_selection_set_mode (kijeloles, GTK_SELECTION_BROWSE);
  g_signal_connect (G_OBJECT (kijeloles), 'changed',
                    G_CALLBACK (@kijeloles_kiir), NULL);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Listanezet');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 500, 300);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_scrolled_window_set_policy
      (PGtkScrolledWindow (gordito), 1, 0);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_container_add (GTK_CONTAINER (vdoboz), gordito);
  gtk_container_add (GTK_CONTAINER (gordito), treeview);
  gtk_box_pack_start (GTK_BOX (vdoboz), hdoboz, false, false, 5);

  gomb := gtk_button_new_from_stock (GTK_STOCK_SORT_ASCENDING);
  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@rendez), NULL);
  gtk_box_pack_start (GTK_BOX (hdoboz), gomb, false, true, 1);

  gomb := gtk_button_new_from_stock (GTK_STOCK_DELETE);
  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@sortorles), NULL);
  gtk_box_pack_start (GTK_BOX (hdoboz), gomb, false, true, 1);

  gomb := gtk_button_new_from_stock (GTK_STOCK_NEW);
  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@sorbeszuras), NULL);
  gtk_box_pack_end (GTK_BOX (hdoboz), gomb, false, true, 1);
  be2 := gtk_check_button_new;
  gtk_box_pack_end (GTK_BOX (hdoboz), be2, false, true, 1);
  be1 := gtk_entry_new;
  gtk_box_pack_end (GTK_BOX (hdoboz), be1, false, true, 1);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.