{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program treeview_select;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

const
  NEV_OSZLOP = 0;
  SZUL_EV_OSZLOP = 1;

type
  TAdat = record
    nev     : PGChar;
    szul_ev : integer;
  end;

var
  adat : array[0..2] of TAdat;
  i    : byte;

  foablak,
  vdoboz,
  gomb,
  gordito,
  treeview  : PGtkWidget;

  oszlop    : PGtkTreeViewColumn;
  renderelo : PGtkCellRenderer;
  alak      : PGtkListStore;
  ismetlo   : TGtkTreeIter;
  kijeloles : PGtkTreeSelection;

procedure kijeloles_kiir;
var
  neve : PGChar;
begin
  if (gtk_tree_selection_get_selected
          (kijeloles, @alak, @ismetlo)) then
  begin
    gtk_tree_model_get (alak, @ismetlo, NEV_OSZLOP, @neve, -1);
    writeln (neve);
  end;
end;

procedure rendez;
begin
  gtk_tree_sortable_set_sort_column_id
      (alak, NEV_OSZLOP, GTK_SORT_ASCENDING);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  gomb := gtk_button_new_from_stock (GTK_STOCK_SORT_ASCENDING);
  gordito := gtk_scrolled_window_new (NULL, NULL);

  ////////// Elkeszites //////////

  alak := gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_INT);
  treeview := gtk_tree_view_new_with_model (alak);
  renderelo := gtk_cell_renderer_text_new;

  oszlop := gtk_tree_view_column_new_with_attributes
                ('Nev:', renderelo, 'text',
                  NEV_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  oszlop := gtk_tree_view_column_new_with_attributes
                ('Szul. ido:', renderelo, 'text',
                  SZUL_EV_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  ////////// Feltoltes //////////

  adat[0].nev := 'Esze T. Lenke';
  adat[0].szul_ev := 1948;
  adat[1].nev := 'Barmi Aron';
  adat[1].szul_ev := 1974;
  adat[2].nev := 'Major Anna';
  adat[2].szul_ev := 1984;

  for i := 0 to 2 do
  begin
    gtk_list_store_append (alak, @ismetlo);
    gtk_list_store_set (alak, @ismetlo,
                          NEV_OSZLOP, adat[i].nev,
                          SZUL_EV_OSZLOP, adat[i].szul_ev,
                          -1);
  end;

  ////////// Kijeloles //////////

  kijeloles := gtk_tree_view_get_selection
                (GTK_TREE_VIEW (treeview));
  gtk_tree_selection_set_mode (kijeloles, GTK_SELECTION_BROWSE);
  g_signal_connect (G_OBJECT (kijeloles), 'changed',
                    G_CALLBACK (@kijeloles_kiir), NULL);

  ////////// Vege //////////

  gtk_window_set_title (GTK_WINDOW (foablak), 'Listanezet');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 250, 200);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_scrolled_window_set_policy
      (PGtkScrolledWindow (gordito), 1, 0);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 5);
  gtk_container_add (GTK_CONTAINER (vdoboz), gordito);
  gtk_container_add (GTK_CONTAINER (gordito), treeview);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@rendez), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.