{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program texteditor;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, pango, sysutils;

var
  foablak, vdoboz,
  menusor, fajlmenu,
  fajl,
  uj,
  megny,
  ment,
  mentm,
  gordito, szdoboz : PGtkWidget;
  puffer           : PGtkTextBuffer;
  betutipus        : TPangoFontDescription;
  fajlnev          : string;

procedure torles;
begin
  gtk_text_buffer_set_text (puffer, '', -1);
end;

procedure megnyitas;
var
  dialog  : PGtkWidget;
  szuro1,
  szuro2  : PGtkFileFilter;
  f       : text;
  sor     : string;
begin
  dialog := gtk_file_chooser_dialog_new
                ('Fajl megnyitasa',
                  GTK_WINDOW (foablak),
                  GTK_FILE_CHOOSER_ACTION_OPEN,
                  GTK_STOCK_OPEN, [GTK_RESPONSE_ACCEPT,
                  GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                  NULL]);
  szuro1 := gtk_file_filter_new;
  gtk_file_filter_add_pattern (szuro1, '*.txt');
  gtk_file_filter_add_pattern (szuro1, '*.inc');
  gtk_file_filter_add_pattern (szuro1, '*.pas');
  gtk_file_filter_add_pattern (szuro1, '*.pp');
  gtk_file_filter_set_name (szuro1,
      'szovegfajlok (txt, inc, pas, pp');
  gtk_file_chooser_add_filter
      (GTK_FILE_CHOOSER (dialog), szuro1);
  szuro2 := gtk_file_filter_new;
  gtk_file_filter_add_pattern (szuro2, '*');
  gtk_file_filter_set_name (szuro2, 'minden fajl');
  gtk_file_chooser_add_filter
      (GTK_FILE_CHOOSER (dialog), szuro2);
  if (gtk_dialog_run (GTK_DIALOG (dialog)) =
      GTK_RESPONSE_ACCEPT) then
  begin
    fajlnev := gtk_file_chooser_get_filename
                     (GTK_FILE_CHOOSER (dialog));
    assign (f, fajlnev);
    try
      reset (f);
      gtk_text_buffer_set_text (puffer, '', -1);
      while not (eof (f)) do
      begin
        readln (f, sor);
        gtk_text_buffer_insert_at_cursor
            (puffer, PGChar (sor+#10), -1);
      end;
    except
      on EInOutError do
      begin
        gtk_window_set_title
            (GTK_WINDOW (foablak), 'Fajlmegnyitasi hiba!');
        exit;
      end;
    end;
    close (f);
  end;
  gtk_widget_destroy (dialog);
  gtk_window_set_title (GTK_WINDOW (foablak),
                        PGChar (fajlnev));
end;

procedure mentesmaskent;
var
  dialog     : PGtkWidget;
  f          : text;
  kar        : string;
  i          : integer;
  itel, itve : TGtkTextIter;
begin
  dialog := gtk_file_chooser_dialog_new
                ('Fajl mentese maskent',
                  GTK_WINDOW (foablak),
                  GTK_FILE_CHOOSER_ACTION_SAVE,
                  GTK_STOCK_SAVE, [GTK_RESPONSE_ACCEPT,
                  GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                  NULL]);
  gtk_file_chooser_set_current_name (dialog,
      'nevtelen.txt');
  if (gtk_dialog_run (GTK_DIALOG (dialog)) =
      GTK_RESPONSE_ACCEPT) then
  begin
    fajlnev := gtk_file_chooser_get_filename
                     (GTK_FILE_CHOOSER (dialog));
    try
      assign (f, fajlnev);
      rewrite (f);
      for i := 0 to
          gtk_text_buffer_get_char_count (puffer) do
      begin
        gtk_text_buffer_get_iter_at_offset
            (puffer, @itel, i);
        gtk_text_buffer_get_iter_at_offset
            (puffer, @itve, i+1);
        kar := gtk_text_buffer_get_text
                   (puffer, @itel, @itve, true);
        write (f, kar);
      end;
    except
      on EInOutError do
      begin
        gtk_window_set_title
            (GTK_WINDOW (foablak), 'Fajlmegnyitasi hiba!');
        exit;
      end;
    end;
    close (f);
  end;
  gtk_widget_destroy (dialog);
  gtk_window_set_title (GTK_WINDOW (foablak),
                        PGChar (fajlnev));
end;

procedure mentes;
var
  f          : text;
  kar        : string;
  i          : integer;
  itel, itve : TGtkTextIter;
begin
  if fajlnev <> '' then
  begin
    try
      assign (f, fajlnev);
      rewrite (f);
      for i := 0 to
          gtk_text_buffer_get_char_count (puffer) do
      begin
        gtk_text_buffer_get_iter_at_offset
            (puffer, @itel, i);
        gtk_text_buffer_get_iter_at_offset
            (puffer, @itve, i+1);
        kar := gtk_text_buffer_get_text
                   (puffer, @itel, @itve, true);
        write (f, kar);
      end;
    except
      on EInOutError do
      begin
        gtk_window_set_title
            (GTK_WINDOW (foablak), 'Fajlmegnyitasi hiba!');
        exit;
      end;
    end;
    close (f);
  end else mentesmaskent;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  menusor := gtk_menu_bar_new;
  fajl := gtk_menu_item_new_with_mnemonic ('_Fajl');
  fajlmenu := gtk_menu_new;
  uj := gtk_image_menu_item_new_from_stock
            (GTK_STOCK_NEW, NULL);
  megny := gtk_image_menu_item_new_from_stock
               (GTK_STOCK_OPEN, NULL);
  ment := gtk_image_menu_item_new_from_stock
              (GTK_STOCK_SAVE, NULL);
  mentm := gtk_image_menu_item_new_from_stock
              (GTK_STOCK_SAVE_AS, NULL);
  gordito := gtk_scrolled_window_new (NULL, NULL);
  puffer := gtk_text_buffer_new (NULL);
  szdoboz := gtk_text_view_new_with_buffer (puffer);

  betutipus := pango_font_description_from_string
                     ('Liberation Mono 11');
  gtk_widget_modify_font (szdoboz, betutipus);
  pango_font_description_free (betutipus);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Szovegszerkeszto');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 550, 300);
  gtk_scrolled_window_set_policy
      (GTK_SCROLLED_WINDOW (gordito), 1, 0);

  gtk_menu_shell_append (GTK_MENU_SHELL (menusor), fajl);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (fajl), fajlmenu);
  gtk_menu_shell_append (GTK_MENU_SHELL (fajlmenu), uj);
  gtk_menu_shell_append (GTK_MENU_SHELL (fajlmenu), megny);
  gtk_menu_shell_append (GTK_MENU_SHELL (fajlmenu), ment);
  gtk_menu_shell_append (GTK_MENU_SHELL (fajlmenu), mentm);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), menusor, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gordito, true, true, 0);
  gtk_container_set_border_width (GTK_CONTAINER (gordito), 3);
  gtk_container_add (GTK_CONTAINER (gordito), szdoboz);

  g_signal_connect (G_OBJECT (uj), 'activate',
                    G_CALLBACK (@torles), NULL);
  g_signal_connect (G_OBJECT (megny), 'activate',
                    G_CALLBACK (@megnyitas), NULL);
  g_signal_connect (G_OBJECT (ment), 'activate',
                    G_CALLBACK (@mentes), NULL);
  g_signal_connect (G_OBJECT (mentm), 'activate',
                    G_CALLBACK (@mentesmaskent), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
