{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program drawing_extra;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2, gdk2pixbuf;

var
  foablak,
  rajztabla,
  vdoboz,
  gomb      : PGtkWidget;
  pixmap    : PGdkPixmap;
  rajzablak : PGdkDrawable;
  szel, mag : longint;

function expose_event (widget:PGtkWidget;
           event:PGdkEventExpose) : gboolean; cdecl;
begin
  rajzablak := widget^.window;
  szel := widget^.allocation.width;
  mag := widget^.allocation.height;

  gdk_draw_drawable (rajzablak,
      widget^.style^.fg_gc[GTK_WIDGET_STATE (widget)],
      pixmap,
      event^.area.x, event^.area.y,
      event^.area.x, event^.area.y,
      event^.area.width, event^.area.height);
  expose_event := false;
end;

function configure_event (widget:PGtkWidget;
           event:PGdkEventConfigure) : gboolean; cdecl;
begin
  if pixmap <> NULL then
    g_object_unref (pixmap);
  pixmap := gdk_pixmap_new (widget^.window,
                widget^.allocation.width,
                widget^.allocation.height,
                -1);
  gdk_draw_rectangle (pixmap,
      widget^.style^.white_gc,
      GTRUE,
      0, 0,
      widget^.allocation.width,
      widget^.allocation.height);
  configure_event := true;
end;

procedure draw_brush (widget:PGtkWidget;
                      x, y  :gdouble); cdecl;
var
  update_rect : TGdkRectangle;

begin
  update_rect.x      := round (x - 5.0);
  update_rect.y      := round (y - 5.0);
  update_rect.width  := 10;
  update_rect.height := 10;

  gdk_draw_rectangle (pixmap,
      widget^.style^.black_gc,
      GTRUE,
      update_rect.x, update_rect.y,
      update_rect.width, update_rect.height);

  gtk_widget_queue_draw_area (widget,
      update_rect.x, update_rect.y,
      update_rect.width, update_rect.height);
end;

function button_press_event (widget:PGtkWidget;
           event:PGdkEventbutton) : gboolean; cdecl;
begin
  if (event^.button = 1) and (pixmap <> NULL) then
    draw_brush (widget, event^.x, event^.y);

  button_press_event := true;
end;

function motion_notify_event (widget:PGtkWidget;
           event:PGdkEventMotion) : gboolean; cdecl;
var
  x, y  : gint;
  state : TGdkModifierType;
begin
  if event^.is_hint = GTRUE then
    gdk_window_get_pointer (event^.window, @x, @y, @state)
  else begin
    x := round (event^.x);
    y := round (event^.y);
    state := event^.state;
  end;

  if ((state and GDK_BUTTON1_MASK) <> 0)
             and (pixmap <> NULL) then
    draw_brush (widget, x, y);

  motion_notify_event := true;
end;

procedure keplopas;
var
  pixbuf : PGdkPixbuf;
  cmap   : PGdkColormap;
begin
  cmap := gdk_colormap_get_system;
  pixbuf :=gdk_pixbuf_get_from_drawable (NULL,
               rajzablak, cmap,
               0, 0, 0, 0, szel, mag);
  gdk_pixbuf_save (pixbuf, 'kep.png', 'png', NULL,
                   [NULL]);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 5);
  rajztabla := gtk_drawing_area_new;
  gomb := gtk_button_new_from_stock
              (GTK_STOCK_SAVE);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Rajztabla');
  gtk_widget_set_size_request (rajztabla, 200, 200);

  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), rajztabla,
                      true, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb, false, false, 0);

  g_signal_connect (G_OBJECT (rajztabla),
                    'expose_event',
                    G_CALLBACK (@expose_event), NULL);

  g_signal_connect (G_OBJECT (rajztabla),
                    'configure_event',
                    G_CALLBACK (@configure_event), NULL);

  g_signal_connect (G_OBJECT (rajztabla),
                    'motion_notify_event',
                    G_CALLBACK (@motion_notify_event), NULL);

  g_signal_connect (G_OBJECT (rajztabla),
                    'button_press_event',
                    G_CALLBACK (@button_press_event), NULL);

  gtk_widget_set_events (rajztabla,
                         GDK_EXPOSURE_MASK
                      or GDK_LEAVE_NOTIFY_MASK
                      or GDK_BUTTON_PRESS_MASK
                      or GDK_POINTER_MOTION_MASK
                      or GDK_POINTER_MOTION_HINT_MASK);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@keplopas), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main; 

end.
