{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program drawing_simple;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2, gdk2pixbuf;

var
  foablak,
  vdoboz,
  gomb,
  rajztabla : PGtkWidget;
  rajzablak : PGdkDrawable;
  szel, mag : longint;

function kirajzol (widget:PGtkWidget;
                   event:PGdkEventExpose;
                   data:gpointer) : gboolean; cdecl;
const
  haziko : array[0..8] of TGdkPoint = 
  ((x: 60; y:150),
   (x: 60; y: 90),
   (x:100; y: 60),
   (x:140; y: 90),
   (x: 60; y: 90),
   (x:140; y:150),
   (x: 60; y:150),
   (x:140; y: 90),
   (x:140; y:150));

var
  szin : TGdkColor;
  gc   : PGdkGC;
begin
  rajzablak := widget^.window;
  szel := widget^.allocation.width;
  mag := widget^.allocation.height;

  gdk_draw_rectangle (rajzablak,
      widget^.style^.white_gc,
      GTRUE,
      0, 0, szel, mag);

  gc := gdk_gc_new (rajzablak);
  szin.red   := 0;
  szin.green := 32000;
  szin.blue  := 0;
  gdk_gc_set_rgb_fg_color (gc, @szin);
  gdk_draw_point (rajzablak, gc, 100, 30);
  gdk_draw_point (rajzablak, gc, 101, 30);
  gdk_draw_point (rajzablak, gc, 102, 30);
  gdk_draw_point (rajzablak, gc, 102, 31);
  gdk_draw_point (rajzablak, gc, 102, 32);

  szin.blue  := 65535;
  gdk_gc_set_rgb_fg_color (gc, @szin);
  gdk_draw_line (rajzablak, gc,
      10, 10, szel-10, mag-10);

  szin.red   := 65535;
  szin.green := 0;
  gdk_gc_set_rgb_fg_color (gc, @szin);
  gdk_draw_lines (rajzablak, gc,
      haziko, high (haziko) + 1);

  szin.blue  := 0;
  szin.green := 32000;
  gdk_gc_set_rgb_fg_color (gc, @szin);
  gdk_gc_set_line_attributes (gc, 2,
      GDK_LINE_ON_OFF_DASH,
      GDK_CAP_NOT_LAST,
      GDK_JOIN_MITER);
  gdk_draw_arc (rajzablak, gc,
      GFALSE,
      5, 5, szel-10, mag-10,
      0, 64*360);

  szin.green := 0;
  gdk_gc_set_rgb_fg_color (gc, @szin);
  gdk_draw_string (rajzablak,
      gdk_font_load ('-adobe-helvetica-bold-r-normal-'+
                     '-12-120-75-75-p-70-iso8859-1'),
      gc,
      30, 25, 'Hello Vilag!');

  kirajzol := false;
end;

procedure keplopas;
var
  pixbuf : PGdkPixbuf;
  cmap   : PGdkColormap;
begin
  cmap := gdk_colormap_get_system;
  pixbuf :=gdk_pixbuf_get_from_drawable (NULL,
               rajzablak, cmap,
               0, 0, 0, 0, szel, mag);
  gdk_pixbuf_save (pixbuf, 'kep.png', 'png', NULL,
                   [NULL]);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 5);
  rajztabla := gtk_drawing_area_new;
  gomb := gtk_button_new_from_stock
              (GTK_STOCK_SAVE);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Rajztabla');
  gtk_widget_set_size_request (rajztabla, 200, 200);

  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), rajztabla,
                      true, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 0);

  g_signal_connect (G_OBJECT (rajztabla), 'expose_event',
                    G_CALLBACK (@kirajzol), NULL);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@keplopas), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
